package com.informit.mywalks;

import java.util.ArrayList;
import java.util.List;

import android.content.Intent;
import android.database.Cursor;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.net.Uri;
import android.os.Bundle;

import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;
import com.google.android.maps.Point;

public class MyWalkView extends MapActivity {
    private Uri mURI;

    private Cursor mCursor;

    private static final String[] PROJECTION = new String[] {
	    Walks.MyPoints.LATITUDE, Walks.MyPoints.LONGITUDE };

    @Override
    protected void onCreate(Bundle arg0) {
	super.onCreate(arg0);

	MapView mv = new MapView(this);
	setContentView(mv);

	final Intent intent = getIntent();

	mURI = intent.getData();

	mCursor = managedQuery(mURI.buildUpon().appendPath("points").build(),
		PROJECTION, null, null);

	MapController mc = mv.getController();
	if (mCursor.first()) {
	    Point p = new Point(mCursor.getInt(0), mCursor.getInt(1));
	    mc.animateTo(p);
	    mc.zoomTo(15);
	}
	WalkOverlay wo = new WalkOverlay();
	mv.createOverlayController().add(wo, true);
    }

    public class WalkOverlay extends Overlay {
	private List<Point> mPoints = new ArrayList<Point>();

	private Paint paint = new Paint();

	public WalkOverlay() {
	    paint.setStrokeWidth(5f);
	    while (mCursor.next()) {
		mPoints.add(new Point(mCursor.getInt(0), mCursor.getInt(1)));
	    }
	}

	@Override
	public void draw(Canvas canvas, PixelCalculator calculator,
		boolean shadow) {
	    int[] temp = new int[2];
	    for (Point p : mPoints) {
		if (mPoints.indexOf(p) == mPoints.size() - 1)
		    break;
		calculator.getPointXY(p, sXYCoords);
		calculator
			.getPointXY(mPoints.get(mPoints.indexOf(p) + 1), temp);
		canvas.drawLine(sXYCoords[0], sXYCoords[1], temp[0], temp[1],
			paint);
	    }
	    super.draw(canvas, calculator, shadow);
	}
    }

}
